import axios from 'axios'
import { LocalStorage } from 'quasar'

const APIQuasarV1 = {
    async run (payload) {
        return new Promise(
            function (resolve, reject) {
                // if (typeof(payload.cartel)!=='undefined') {
                //     store.dispatch('loading/mostrar', payload.cartel)
                // }
                if (typeof(payload.metodo)=="undefined") {
                    payload.metodo="GET"
                }

                const prefijoURL=process.env.API_URL

                // let timeout=180000
                // if (typeof(payload.timeout)!="undefined") {
                //   timeout=payload.timeout
                // }

                // axios(prefijoURL+payload.ruta, {timeout, method: payload.metodo, data: payload.data, headers: {LSIPass: process.env.API_LSIPass, LSIToken: LocalStorage.getItem("token")}})
                axios(prefijoURL+payload.ruta, {method: payload.metodo, data: payload.data, headers: {LSIPass: process.env.API_LSIPass, LSIToken: LocalStorage.getItem("token")}})
                .then(datos => {
                    if (datos.data.status.toUpperCase()=="OK") {
                        resolve(datos.data.data)
                    } else {
                      if (datos.data.errors==="LSI:TokenVencido") {

                        //El token está vencido, tengo que pedir uno nuevo
                        axios(prefijoURL+"/auth/refreshToken", {method: "POST", data: {Token: LocalStorage.getItem("token")}, headers: {LSIPass: process.env.API_LSIPass}})
                        .then( datos => {
                          if (datos.data.status.toUpperCase()=="OK") {

                            //Token refrescado obtenido correctamente, y guardado
                            LocalStorage.set("token", datos.data.data.AccessToken)

                            //Vuelvo a hacer la operación original
                            axios(prefijoURL+payload.ruta, { method: payload.metodo, data: payload.data, headers: {LSIPass: process.env.API_LSIPass, LSIToken: LocalStorage.getItem("token")}})
                            .then(datos => {
                              if (datos.data.status.toUpperCase()=="OK") {

                                //La operación original se pudo hacer correctamente
                                  resolve(datos.data.data)
                              } else {

                                //La operación original NO se pudo hacer correctamente.
                                reject(datos.data.errors)
                              }}
                            )
                          } else {
                            console.log("Error en respuesta de refresh del token", datos.data.errors)
                            reject(datos.data.errors)
                          }
                        })
                        .catch( error => {
                          console.log("Error en refresh", error)
                          reject(error)
                        })
                      } else if (datos.data.errors==="LSI:TokenInvalido")  {
                        const error="Token invalido, vamos a Login"
                        console.log(error)
                        location.href="/login"
                        reject(error)
                      } else if (datos.data.errors==="LSI:TokenInexistente")  {
                        const error="Token inexistente, vamos a Login"
                        console.log(error)
                        location.href="/login"
                        reject(error)
                      } else if (datos.data.errors==="LSI:TokenMalformado")  {
                        const error="Token malformado, vamos a Login"
                        console.log(error)
                        location.href="/login"
                        reject(error)
                      } else {
                        reject(datos.data.errors)
                      }
                    }
                })
                .catch(error => {
                  if (error.code === 'ECONNABORTED') {
                    reject("El servidor no respondió a tiempo. Intenta nuevamente.")
                  } else if (error.response.status===404) {
                    reject("No se pudo conectar con el recurso en el servidor. El servidor está operativo?")
                  } else {
                    reject(error)
                  }
                })
                .finally( () => {
                    // if (typeof(payload.Cartel)!=='undefined') {
                    //     store.dispatch('loading/ocultar')
                    // }
                })
            }
        )
    }
}

export default APIQuasarV1
