
const cadenas = {
    stringToSlug(texto) {
        const result = texto
            .toString()
            .normalize('NFD')
            .toLowerCase()
            .trim()
            .replace(/\s+/g, '_')
            .replace(/[^\w\-]+/g, '')    
        return result    
    },
    stringToFileName(input) {
        // Reemplazar caracteres inválidos
        const sanitized = input.replace(/[\\/:*?"<>|]/g, '_')
        
        // Remover nombres reservados de Windows
        const reservedNames = ['CON', 'PRN', 'AUX', 'NUL', 'COM1', 'COM2', 'COM3', 'COM4', 'COM5', 'COM6', 'COM7', 'COM8', 'COM9', 'LPT1', 'LPT2', 'LPT3', 'LPT4', 'LPT5', 'LPT6', 'LPT7', 'LPT8', 'LPT9']
        const baseName = sanitized.split('.').shift().toUpperCase()
        if (reservedNames.includes(baseName)) {
            return `_${sanitized}`
        }
        
        return sanitized
    }
}

export default cadenas